#!/usr/bin/env python

import md5;
import os.path;
import sys;

thisScript = os.path.abspath(sys.argv.pop(0));
scriptBase = os.path.basename(thisScript);

if (len(sys.argv) != 4) :
    sys.exit("Usage: " + scriptBase + " fileName url directory md5");

fileName    = sys.argv.pop(0);
packageUrl  = sys.argv.pop(0);
packageDir  = sys.argv.pop(0);
expectedMd5 = sys.argv.pop(0);

fullFileName = os.path.join(packageDir, fileName);

# Download the file if it doesn't already exist
if (not os.path.isfile(fullFileName)) :
    if (not os.path.isdir(packageDir)) :
        os.makedirs(packageDir);
    
    print("Downloading " + fileName);
    os.system("wget -N -O " + fullFileName + " " + packageUrl + "/" + fileName);

# Ensure that the file exists and is valid
if (os.path.isfile(fullFileName)) :
    contents  = "".join(file(fullFileName, "r").readlines());
    actualMd5 = md5.new(contents).hexdigest();
    #if (actualMd5 != expectedMd5) :
    #    os.remove(fullFileName);
    #    sys.exit("MD5 does not match expected for " + fileName + "!");
    
    # Create an empty file to use as a dependency
    kludgeFile = os.path.join(packageDir, ".downloaded_" + fileName);
    if (not os.path.isfile(kludgeFile)) :
        file(kludgeFile, "w").close();
else :
    sys.exit("Unable to download " + fileName + " from " + packageUrl + "!");

sys.exit(0);
